#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_ActivitySummerPlanRoketCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_ActivitySummerPlanRoketCFG> M_ActivitySummerPlanRoketCFG::msSingleton(nullptr);

int M_ActivitySummerPlanRoketCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySummerPlanRoketCFGData* M_ActivitySummerPlanRoketCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_ActivitySummerPlanRoketCFGData>& M_ActivitySummerPlanRoketCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySummerPlanRoketCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_ActivitySummerPlanRoketCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySummerPlanRoketCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mHeight = element->IntAttribute("Height");
		data.mGiftID = element->IntAttribute("GiftID");
		data.mWeight = element->IntAttribute("Weight");
		{
			const char* ShowItem = element->Attribute("ShowItem");
			std::vector<std::string> vecShowItem;
			boost::split(vecShowItem, ShowItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecShowItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecShowItem[i].c_str(), &temp))
				{
					data.mShowItem.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_ActivitySummerPlanRoketCFG::Load()
{
	Load("../Config/M_ActivitySummerPlanRoketCFG.xml");
}

M_ActivitySummerPlanRoketCFG* M_ActivitySummerPlanRoketCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySummerPlanRoketCFG());
	}
	return msSingleton.get();
}
